3 # resolve python-version to use
4 if [ "$PYTHON" == "" ] ; then
5 if ! PYTHON=$(command -v python || command -v python2 || command -v python 2.7)
7 echo "Unable to locate build-dependency python2.x!" 1>&2
12 # validate python-dependency
13 # useful in case of explicitly set option.
14 if ! command -v $PYTHON > /dev/null
16 echo "Unable to locate build-dependency python2.x ($PYTHON)!" 1>&2
22 echo "Usage: $0 [BuildArch] [BuildType] [-verbose] [-coverage] [-cross] [-clangx.y] [-ninja] [-configureonly] [-skipconfigure] [-skipnative] [-skipmscorlib] [-skiptests] [-stripsymbols] [-ignorewarnings] [-cmakeargs] [-bindir]"
23 echo "BuildArch can be: -x64, -x86, -arm, -armel, -arm64"
24 echo "BuildType can be: -debug, -checked, -release"
25 echo "-coverage - optional argument to enable code coverage build (currently supported only for Linux and OSX)."
26 echo "-ninja - target ninja instead of GNU make"
27 echo "-clangx.y - optional argument to build using clang version x.y."
28 echo "-cross - optional argument to signify cross compilation,"
29 echo " - will use ROOTFS_DIR environment variable if set."
30 echo "-crosscomponent - optional argument to build cross-architecture component,"
31 echo " - will use CAC_ROOTFS_DIR environment variable if set."
32 echo "-nopgooptimize - do not use profile guided optimizations."
33 echo "-pgoinstrument - generate instrumented code for profile guided optimization enabled binaries."
34 echo "-ibcinstrument - generate IBC-tuning-enabled native images when invoking crossgen."
35 echo "-configureonly - do not perform any builds; just configure the build."
36 echo "-skipconfigure - skip build configuration."
37 echo "-skipnative - do not build native components."
38 echo "-skipmscorlib - do not build mscorlib.dll."
39 echo "-skiptests - skip the tests in the 'tests' subdirectory."
40 echo "-skipnuget - skip building nuget packages."
41 echo "-skiprestoreoptdata - skip restoring optimization data used by profile-based optimizations."
42 echo "-skipcrossgen - skip native image generation"
43 echo "-verbose - optional argument to enable verbose build output."
44 echo "-skiprestore: skip restoring packages ^(default: packages are restored during build^)."
45 echo "-disableoss: Disable Open Source Signing for System.Private.CoreLib."
46 echo "-officialbuildid=^<ID^>: specify the official build ID to be used by this build."
47 echo "-Rebuild: passes /t:rebuild to the build projects."
48 echo "-stripSymbols - Optional argument to strip native symbols during the build."
49 echo "-skipgenerateversion - disable version generation even if MSBuild is supported."
50 echo "-ignorewarnings - do not treat warnings as errors"
51 echo "-cmakeargs - user-settable additional arguments passed to CMake."
52 echo "-bindir - output directory (defaults to $__ProjectRoot/bin)"
53 echo "-buildstandalonegc - builds the GC in a standalone mode. Can't be used with \"cmakeargs\"."
54 echo "-msbuildonunsupportedplatform - build managed binaries even if distro is not officially supported."
55 echo "-numproc - set the number of build processes."
62 if [ "$__HostOS" == "Linux" ]; then
63 if [ -e /etc/os-release ]; then
64 source /etc/os-release
65 if [[ $ID == "alpine" ]]; then
66 # remove the last version digit
67 VERSION_ID=${VERSION_ID%.*}
69 __HostDistroRid="$ID.$VERSION_ID-$__HostArch"
70 elif [ -e /etc/redhat-release ]; then
71 local redhatRelease=$(</etc/redhat-release)
72 if [[ $redhatRelease == "CentOS release 6."* || $redhatRelease == "Red Hat Enterprise Linux Server release 6."* ]]; then
73 __HostDistroRid="rhel.6-$__HostArch"
78 if [ "$__HostDistroRid" == "" ]; then
79 echo "WARNING: Can not determine runtime id for current distro."
85 if [ $__CrossBuild == 1 ]; then
86 if [ "$__BuildOS" == "Linux" ]; then
87 if [ ! -e $ROOTFS_DIR/etc/os-release ]; then
88 if [ -e $ROOTFS_DIR/android_platform ]; then
89 source $ROOTFS_DIR/android_platform
90 export __DistroRid="$RID"
92 echo "WARNING: Can not determine runtime id for current distro."
96 source $ROOTFS_DIR/etc/os-release
97 export __DistroRid="$ID.$VERSION_ID-$__BuildArch"
101 export __DistroRid="$__HostDistroRid"
104 # Portable builds target the base RID
105 if [ $__PortableBuild == 1 ]; then
106 if [ "$__BuildOS" == "Linux" ]; then
107 export __DistroRid="linux-$__BuildArch"
108 elif [ "$__BuildOS" == "OSX" ]; then
109 export __DistroRid="osx-$__BuildArch"
116 echo Setting up directories for build
118 mkdir -p "$__RootBinDir"
120 mkdir -p "$__LogsDir"
121 mkdir -p "$__IntermediatesDir"
123 if [ $__CrossBuild == 1 ]; then
124 mkdir -p "$__CrossComponentBinDir"
125 mkdir -p "$__CrossCompIntermediatesDir"
129 # Check the system to ensure the right prereqs are in place
133 echo "Checking prerequisites..."
135 # Check presence of CMake on the path
136 hash cmake 2>/dev/null || { echo >&2 "Please install cmake before running this script"; exit 1; }
139 # Minimum required version of clang is version 3.9 for arm/armel cross build
140 if [[ $__CrossBuild == 1 && ("$__BuildArch" == "arm" || "$__BuildArch" == "armel") ]]; then
141 if ! [[ "$__ClangMajorVersion" -gt "3" || ( $__ClangMajorVersion == 3 && $__ClangMinorVersion == 9 ) ]]; then
142 echo "Please install clang3.9 or latest for arm/armel cross build"; exit 1;
147 hash clang-$__ClangMajorVersion.$__ClangMinorVersion 2>/dev/null || hash clang$__ClangMajorVersion$__ClangMinorVersion 2>/dev/null || hash clang 2>/dev/null || { echo >&2 "Please install clang-$__ClangMajorVersion.$__ClangMinorVersion before running this script"; exit 1; }
153 # we only need optdata on a Release build
154 if [[ "$__BuildType" != "Release" ]]; then __SkipRestoreOptData=1; fi
156 if [[ ( $__SkipRestoreOptData == 0 ) && ( $__isMSBuildOnNETCoreSupported == 1 ) ]]; then
157 echo "Restoring the OptimizationData package"
158 "$__ProjectRoot/run.sh" sync -optdata
160 echo "Failed to restore the optimization data package."
165 if [ $__isMSBuildOnNETCoreSupported == 1 ]; then
166 # Parse the optdata package versions out of msbuild so that we can pass them on to CMake
167 local DotNetCli="$__ProjectRoot/Tools/dotnetcli/dotnet"
168 if [ ! -f $DotNetCli ]; then
169 "$__ProjectRoot/init-tools.sh"
171 echo "Failed to restore buildtools."
175 local OptDataProjectFilePath="$__ProjectRoot/src/.nuget/optdata/optdata.csproj"
176 __PgoOptDataVersion=$(DOTNET_SKIP_FIRST_TIME_EXPERIENCE=1 $DotNetCli msbuild $OptDataProjectFilePath /t:DumpPgoDataPackageVersion /nologo | sed 's/^\s*//')
177 __IbcOptDataVersion=$(DOTNET_SKIP_FIRST_TIME_EXPERIENCE=1 $DotNetCli msbuild $OptDataProjectFilePath /t:DumpIbcDataPackageVersion /nologo | sed 's/^\s*//')
181 generate_event_logging_sources()
183 if [ $__SkipCoreCLR == 1 ]; then
187 # Event Logging Infrastructure
188 __GeneratedIntermediate="$__IntermediatesDir/Generated"
189 __GeneratedIntermediateEventProvider="$__GeneratedIntermediate/eventprovider_new"
190 __GeneratedIntermediateEventPipe="$__GeneratedIntermediate/eventpipe_new"
192 if [[ -d "$__GeneratedIntermediateEventProvider" ]]; then
193 rm -rf "$__GeneratedIntermediateEventProvider"
196 if [[ -d "$__GeneratedIntermediateEventPipe" ]]; then
197 rm -rf "$__GeneratedIntermediateEventPipe"
200 if [[ ! -d "$__GeneratedIntermediate/eventprovider" ]]; then
201 mkdir -p "$__GeneratedIntermediate/eventprovider"
204 if [[ ! -d "$__GeneratedIntermediate/eventpipe" ]]; then
205 mkdir -p "$__GeneratedIntermediate/eventpipe"
208 mkdir -p "$__GeneratedIntermediateEventProvider"
209 mkdir -p "$__GeneratedIntermediateEventPipe"
211 __PythonWarningFlags="-Wall"
212 if [[ $__IgnoreWarnings == 0 ]]; then
213 __PythonWarningFlags="$__PythonWarningFlags -Werror"
217 if [[ $__SkipCoreCLR == 0 || $__ConfigureOnly == 1 ]]; then
218 echo "Laying out dynamically generated files consumed by the build system "
219 echo "Laying out dynamically generated Event Logging Test files"
220 $PYTHON -B $__PythonWarningFlags "$__ProjectRoot/src/scripts/genXplatEventing.py" --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --exc "$__ProjectRoot/src/vm/ClrEtwAllMeta.lst" --testdir "$__GeneratedIntermediateEventProvider/tests"
222 if [[ $? != 0 ]]; then
228 echo "Laying out dynamically generated EventPipe Implementation"
229 $PYTHON -B $__PythonWarningFlags "$__ProjectRoot/src/scripts/genEventPipe.py" --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --intermediate "$__GeneratedIntermediateEventPipe" --exc "$__ProjectRoot/src/vm/ClrEtwAllMeta.lst"
230 if [[ $? != 0 ]]; then
238 #determine the logging system
241 echo "Laying out dynamically generated Event Logging Implementation of Lttng"
242 $PYTHON -B $__PythonWarningFlags "$__ProjectRoot/src/scripts/genXplatLttng.py" --man "$__ProjectRoot/src/vm/ClrEtwAll.man" --intermediate "$__GeneratedIntermediateEventProvider"
243 if [[ $? != 0 ]]; then
252 echo "Cleaning the temp folder of dynamically generated Event Logging files"
253 $PYTHON -B $__PythonWarningFlags -c "import sys;sys.path.insert(0,\"$__ProjectRoot/src/scripts\"); from Utilities import *;UpdateDirectory(\"$__GeneratedIntermediate/eventprovider\",\"$__GeneratedIntermediateEventProvider\")"
254 if [[ $? != 0 ]]; then
258 rm -rf "$__GeneratedIntermediateEventProvider"
260 echo "Cleaning the temp folder of dynamically generated EventPipe files"
261 $PYTHON -B $__PythonWarningFlags -c "import sys;sys.path.insert(0,\"$__ProjectRoot/src/scripts\"); from Utilities import *;UpdateDirectory(\"$__GeneratedIntermediate/eventpipe\",\"$__GeneratedIntermediateEventPipe\")"
262 if [[ $? != 0 ]]; then
266 rm -rf "$__GeneratedIntermediateEventPipe"
273 intermediatesForBuild="$3"
274 extraCmakeArguments="$4"
277 if [ $skipCondition == 1 ]; then
278 echo "Skipping $message build."
282 # All set to commence the build
283 echo "Commencing build of $message for $__BuildOS.$__BuildArch.$__BuildType in $intermediatesForBuild"
288 if [ $__UseNinja == 1 ]; then
290 buildFile="build.ninja"
291 if ! buildTool=$(command -v ninja || command -v ninja-build); then
292 echo "Unable to locate ninja!" 1>&2
297 if [ $__SkipConfigure == 0 ]; then
298 # if msbuild is not supported, then set __SkipGenerateVersion to 1
299 if [ $__isMSBuildOnNETCoreSupported == 0 ]; then __SkipGenerateVersion=1; fi
300 # Drop version.cpp file
301 __versionSourceFile="$intermediatesForBuild/version.cpp"
302 if [ $__SkipGenerateVersion == 0 ]; then
304 "$__ProjectRoot/run.sh" build -Project=$__ProjectDir/build.proj -generateHeaderUnix -NativeVersionSourceFile=$__versionSourceFile $__RunArgs $__UnprocessedBuildArgs
306 # Generate the dummy version.cpp, but only if it didn't exist to make sure we don't trigger unnecessary rebuild
307 __versionSourceLine="static char sccsid[] __attribute__((used)) = \"@(#)No version information produced\";"
308 if [ -e $__versionSourceFile ]; then
309 read existingVersionSourceLine < $__versionSourceFile
311 if [ "$__versionSourceLine" != "$existingVersionSourceLine" ]; then
312 echo $__versionSourceLine > $__versionSourceFile
317 pushd "$intermediatesForBuild"
318 # Regenerate the CMake solution
319 echo "Invoking \"$__ProjectRoot/src/pal/tools/gen-buildsys-clang.sh\" \"$__ProjectRoot\" $__ClangMajorVersion $__ClangMinorVersion $platformArch $__BuildType $__CodeCoverage $__IncludeTests $generator $extraCmakeArguments $__cmakeargs"
320 "$__ProjectRoot/src/pal/tools/gen-buildsys-clang.sh" "$__ProjectRoot" $__ClangMajorVersion $__ClangMinorVersion $platformArch $__BuildType $__CodeCoverage $__IncludeTests $generator "$extraCmakeArguments" "$__cmakeargs"
324 if [ ! -f "$intermediatesForBuild/$buildFile" ]; then
325 echo "Failed to generate $message build project!"
330 if [ $__ConfigureOnly == 1 ]; then
331 echo "Finish configuration & skipping $message build."
335 # Check that the makefiles were created.
336 pushd "$intermediatesForBuild"
338 echo "Executing $buildTool install -j $__NumProc"
340 $buildTool install -j $__NumProc
342 echo "Failed to build $message."
349 build_cross_arch_component()
351 __SkipCrossArchBuild=1
353 # check supported cross-architecture components host(__HostArch)/target(__BuildArch) pair
354 if [[ ("$__BuildArch" == "arm" || "$__BuildArch" == "armel") && "$__CrossArch" == "x86" ]]; then
355 export CROSSCOMPILE=0
356 __SkipCrossArchBuild=0
358 # building x64-host/arm-target cross-architecture component need to use cross toolchain of x86
359 if [ "$__HostArch" == "x64" ]; then
360 export CROSSCOMPILE=1
367 export __CMakeBinDir="$__CrossComponentBinDir"
368 export CROSSCOMPONENT=1
371 if [ $CROSSCOMPILE == 1 ]; then
372 TARGET_ROOTFS="$ROOTFS_DIR"
373 if [ -n "$CAC_ROOTFS_DIR" ]; then
374 export ROOTFS_DIR="$CAC_ROOTFS_DIR"
376 export ROOTFS_DIR="$__ProjectRoot/cross/rootfs/$__CrossArch"
380 __ExtraCmakeArgs="-DCLR_CMAKE_TARGET_ARCH=$__BuildArch -DCLR_CMAKE_TARGET_OS=$__BuildOS -DCLR_CMAKE_PACKAGES_DIR=$__PackagesDir -DCLR_CMAKE_PGO_INSTRUMENT=$__PgoInstrument -DCLR_CMAKE_OPTDATA_VERSION=$__PgoOptDataVersion -DCLR_CMAKE_PGO_OPTIMIZE=$__PgoOptimize"
381 build_native $__SkipCrossArchBuild "$__CrossArch" "$__CrossCompIntermediatesDir" "$__ExtraCmakeArgs" "cross-architecture component"
383 # restore ROOTFS_DIR, CROSSCOMPONENT, and CROSSCOMPILE
384 if [ -n "$TARGET_ROOTFS" ]; then
385 export ROOTFS_DIR="$TARGET_ROOTFS"
387 export CROSSCOMPONENT=
388 export CROSSCOMPILE=1
391 isMSBuildOnNETCoreSupported()
393 __isMSBuildOnNETCoreSupported=$__msbuildonunsupportedplatform
395 if [ $__isMSBuildOnNETCoreSupported == 1 ]; then
399 if [ "$__HostArch" == "x64" ]; then
400 if [ "$__HostOS" == "Linux" ]; then
401 __isMSBuildOnNETCoreSupported=1
402 # note: the RIDs below can use globbing patterns
403 UNSUPPORTED_RIDS=("debian.9-x64" "ubuntu.17.04-x64")
404 for UNSUPPORTED_RID in "${UNSUPPORTED_RIDS[@]}"
406 if [[ $__HostDistroRid == $UNSUPPORTED_RID ]]; then
407 __isMSBuildOnNETCoreSupported=0
411 elif [ "$__HostOS" == "OSX" ]; then
412 __isMSBuildOnNETCoreSupported=1
420 if [ $__SkipCrossgen == 1 ]; then
421 echo "Skipping generating native image"
425 if [ $__SkipCoreCLR == 0 -a -e $__BinDir/crossgen ]; then
426 echo "Generating native image for System.Private.CoreLib."
427 echo "$__BinDir/crossgen /Platform_Assemblies_Paths $__BinDir/IL $__IbcTuning /out $__BinDir/System.Private.CoreLib.dll $__BinDir/IL/System.Private.CoreLib.dll"
428 $__BinDir/crossgen /Platform_Assemblies_Paths $__BinDir/IL $__IbcTuning /out $__BinDir/System.Private.CoreLib.dll $__BinDir/IL/System.Private.CoreLib.dll
429 if [ $? -ne 0 ]; then
430 echo "Failed to generate native image for System.Private.CoreLib."
434 if [ "$__BuildOS" == "Linux" ]; then
435 echo "Generating symbol file for System.Private.CoreLib."
436 $__BinDir/crossgen /CreatePerfMap $__BinDir $__BinDir/System.Private.CoreLib.dll
437 if [ $? -ne 0 ]; then
438 echo "Failed to generate symbol file for System.Private.CoreLib."
448 if [ $__isMSBuildOnNETCoreSupported == 0 ]; then
449 echo "System.Private.CoreLib.dll build unsupported."
453 if [ $__SkipMSCorLib == 1 ]; then
454 echo "Skipping building System.Private.CoreLib."
458 echo "Commencing build of managed components for $__BuildOS.$__BuildArch.$__BuildType"
462 if [[ "$__IbcTuning" -eq "" ]]; then
463 __ExtraBuildArgs="$__ExtraBuildArgs -OptimizationDataDir=\"$__PackagesDir/optimization.$__BuildOS-$__BuildArch.IBC.CoreCLR/$__IbcOptDataVersion/data/\""
464 __ExtraBuildArgs="$__ExtraBuildArgs -EnableProfileGuidedOptimization=true"
466 $__ProjectRoot/run.sh build -Project=$__ProjectDir/build.proj -MsBuildLog="/flp:Verbosity=normal;LogFile=$__LogsDir/System.Private.CoreLib_$__BuildOS__$__BuildArch__$__BuildType.log" -BuildTarget -__IntermediatesDir=$__IntermediatesDir -__RootBinDir=$__RootBinDir -BuildNugetPackage=false -UseSharedCompilation=false $__RunArgs $__ExtraBuildArgs $__UnprocessedBuildArgs
468 if [ $? -ne 0 ]; then
469 echo "Failed to build managed components."
473 # The cross build generates a crossgen with the target architecture.
474 if [ $__CrossBuild != 1 ]; then
475 # The architecture of host pc must be same architecture with target.
476 if [[ ( "$__HostArch" == "$__BuildArch" ) ]]; then
478 elif [[ ( "$__HostArch" == "x64" ) && ( "$__BuildArch" == "x86" ) ]]; then
480 elif [[ ( "$__HostArch" == "arm64" ) && ( "$__BuildArch" == "arm" ) ]]; then
488 generate_NugetPackages()
490 # We can only generate nuget package if we also support building mscorlib as part of this build.
491 if [ $__isMSBuildOnNETCoreSupported == 0 ]; then
492 echo "Nuget package generation unsupported."
496 # Since we can build mscorlib for this OS, did we build the native components as well?
497 if [ $__SkipCoreCLR == 1 ]; then
498 echo "Unable to generate nuget packages since native components were not built."
502 echo "Generating nuget packages for "$__BuildOS
503 echo "DistroRid is "$__DistroRid
504 echo "ROOTFS_DIR is "$ROOTFS_DIR
506 $__ProjectRoot/run.sh build -Project=$__SourceDir/.nuget/packages.builds -MsBuildLog="/flp:Verbosity=normal;LogFile=$__LogsDir/Nuget_$__BuildOS__$__BuildArch__$__BuildType.log" -BuildTarget -__IntermediatesDir=$__IntermediatesDir -__RootBinDir=$__RootBinDir -BuildNugetPackage=false -UseSharedCompilation=false $__RunArgs $__UnprocessedBuildArgs
508 if [ $? -ne 0 ]; then
509 echo "Failed to generate Nuget packages."
514 echo "Commencing CoreCLR Repo build"
516 # Argument types supported by this script:
518 # Build architecture - valid values are: x64, ARM.
519 # Build Type - valid values are: Debug, Checked, Release
521 # Set the default arguments for build
523 # Obtain the location of the bash script to figure out where the root of the repo is.
524 __ProjectRoot="$( cd "$( dirname "${BASH_SOURCE[0]}" )" && pwd )"
526 # Use uname to determine what the CPU is.
528 # Some Linux platforms report unknown for platform, but the arch for machine.
529 if [ "$CPUName" == "unknown" ]; then
535 echo "Unsupported CPU $CPUName detected, build might not succeed!"
546 echo "Unsupported CPU $CPUName detected, build might not succeed!"
557 echo "Unknown CPU $CPUName detected, configuring as if for x64"
563 # Use uname to determine what the OS is.
597 echo "Unsupported OS $OSName detected, configuring as if for Linux"
605 __IncludeTests=Include_Tests
608 # Set the various build properties here so that CMake and MSBuild can pick them up
609 __ProjectDir="$__ProjectRoot"
610 __SourceDir="$__ProjectDir/src"
611 __PackagesDir="$__ProjectDir/packages"
612 __RootBinDir="$__ProjectDir/bin"
613 __UnprocessedBuildArgs=
627 __SkipRestoreOptData=0
630 __ClangMajorVersion=0
631 __ClangMinorVersion=0
632 __NuGetPath="$__PackagesDir/NuGet.exe"
636 __SkipGenerateVersion=0
639 __msbuildonunsupportedplatform=0
640 __PgoOptDataVersion=""
641 __IbcOptDataVersion=""
643 # Get the number of processors available to the scheduler
644 # Other techniques such as `nproc` only get the number of
645 # processors available to a single process.
646 if [ `uname` = "FreeBSD" ]; then
647 __NumProc=`sysctl hw.ncpu | awk '{ print $2+1 }'`
648 elif [ `uname` = "NetBSD" ]; then
649 __NumProc=$(($(getconf NPROCESSORS_ONLN)+1))
650 elif [ `uname` = "Darwin" ]; then
651 __NumProc=$(($(getconf _NPROCESSORS_ONLN)+1))
653 __NumProc=$(nproc --all)
657 if [ $# -le 0 ]; then
661 lowerI="$(echo $1 | awk '{print tolower($0)}')"
701 __CodeCoverage=Coverage
708 -portablebuild=false)
716 stripsymbols|-stripsymbols)
717 __cmakeargs="$__cmakeargs -DSTRIP_SYMBOLS=true"
721 __ClangMajorVersion=3
722 __ClangMinorVersion=5
726 __ClangMajorVersion=3
727 __ClangMinorVersion=6
731 __ClangMajorVersion=3
732 __ClangMinorVersion=7
736 __ClangMajorVersion=3
737 __ClangMinorVersion=8
741 __ClangMajorVersion=3
742 __ClangMinorVersion=9
746 __ClangMajorVersion=4
747 __ClangMinorVersion=0
754 pgoinstrument|-pgoinstrument)
758 nopgooptimize|-nopgooptimize)
760 __SkipRestoreOptData=1
763 ibcinstrument|-ibcinstrument)
764 __IbcTuning="/Tuning"
767 configureonly|-configureonly)
773 skipconfigure|-skipconfigure)
777 skipnative|-skipnative)
778 # Use "skipnative" to use the same option name as build.cmd.
782 skipcoreclr|-skipcoreclr)
783 # Accept "skipcoreclr" for backwards-compatibility.
787 crosscomponent|-crosscomponent)
791 skipmscorlib|-skipmscorlib)
795 skipgenerateversion|-skipgenerateversion)
796 __SkipGenerateVersion=1
799 skiprestoreoptdata|-skiprestoreoptdata)
800 __SkipRestoreOptData=1
803 skipcrossgen|-skipcrossgen)
807 includetests|-includetests)
810 skiptests|-skiptests)
814 skipnuget|-skipnuget)
818 ignorewarnings|-ignorewarnings)
820 __cmakeargs="$__cmakeargs -DCLR_CMAKE_WARNINGS_ARE_ERRORS=OFF"
823 cmakeargs|-cmakeargs)
825 __cmakeargs="$__cmakeargs $2"
828 echo "ERROR: 'cmakeargs' requires a non-empty option argument"
836 if [ ! -d $__RootBinDir ]; then
839 __RootBinParent=$(dirname $__RootBinDir)
840 __RootBinName=${__RootBinDir##*/}
841 __RootBinDir="$(cd $__RootBinParent &>/dev/null && printf %s/%s $PWD $__RootBinName)"
844 echo "ERROR: 'bindir' requires a non-empty option argument"
848 buildstandalonegc|-buildstandalonegc)
849 __cmakeargs="$__cmakeargs -DFEATURE_STANDALONE_GC=1 -DFEATURE_STANDALONE_GC_ONLY=1"
851 msbuildonunsupportedplatform|-msbuildonunsupportedplatform)
852 __msbuildonunsupportedplatform=1
859 echo "ERROR: 'numproc' requires a non-empty option argument"
864 __UnprocessedBuildArgs="$__UnprocessedBuildArgs $1"
871 __RunArgs="-BuildArch=$__BuildArch -BuildType=$__BuildType -BuildOS=$__BuildOS"
873 # Configure environment if we are doing a verbose build
874 if [ $__VerboseBuild == 1 ]; then
876 __RunArgs="$__RunArgs -verbose"
879 # Set default clang version
880 if [[ $__ClangMajorVersion == 0 && $__ClangMinorVersion == 0 ]]; then
881 if [ $__CrossBuild == 1 ]; then
882 if [[ "$__BuildArch" == "arm" || "$__BuildArch" == "armel" ]]; then
883 __ClangMajorVersion=3
884 __ClangMinorVersion=9
886 __ClangMajorVersion=3
887 __ClangMinorVersion=6
891 __ClangMajorVersion=3
892 __ClangMinorVersion=5
896 if [[ "$__BuildArch" == "armel" ]]; then
897 # Armel cross build is Tizen specific and does not support Portable RID build
901 if [ $__PortableBuild == 0 ]; then
902 __RunArgs="$__RunArgs -PortableBuild=false"
905 # Set dependent variables
906 __LogsDir="$__RootBinDir/Logs"
908 # init the host distro name
911 # Set the remaining variables based upon the determined build configuration
912 __BinDir="$__RootBinDir/Product/$__BuildOS.$__BuildArch.$__BuildType"
913 __PackagesBinDir="$__BinDir/.nuget"
914 __ToolsDir="$__RootBinDir/tools"
915 __TestWorkingDir="$__RootBinDir/tests/$__BuildOS.$__BuildArch.$__BuildType"
916 export __IntermediatesDir="$__RootBinDir/obj/$__BuildOS.$__BuildArch.$__BuildType"
917 __TestIntermediatesDir="$__RootBinDir/tests/obj/$__BuildOS.$__BuildArch.$__BuildType"
918 __isMSBuildOnNETCoreSupported=0
919 __CrossComponentBinDir="$__BinDir"
920 __CrossCompIntermediatesDir="$__IntermediatesDir/crossgen"
922 __CrossArch="$__HostArch"
923 if [[ "$__HostArch" == "x64" && ("$__BuildArch" == "arm" || "$__BuildArch" == "armel") ]]; then
926 if [ $__CrossBuild == 1 ]; then
927 __CrossComponentBinDir="$__CrossComponentBinDir/$__CrossArch"
929 __CrossgenCoreLibLog="$__LogsDir/CrossgenCoreLib_$__BuildOS.$BuildArch.$__BuildType.log"
930 __CrossgenExe="$__CrossComponentBinDir/crossgen"
932 # Init if MSBuild for .NET Core is supported for this platform
933 isMSBuildOnNETCoreSupported
935 # CI_SPECIFIC - On CI machines, $HOME may not be set. In such a case, create a subfolder and set the variable to set.
936 # This is needed by CLI to function.
937 if [ -z "$HOME" ]; then
938 if [ ! -d "$__ProjectDir/temp_home" ]; then
941 export HOME=$__ProjectDir/temp_home
942 echo "HOME not defined; setting it to $HOME"
945 # Specify path to be set for CMAKE_INSTALL_PREFIX.
946 # This is where all built CoreClr libraries will copied to.
947 export __CMakeBinDir="$__BinDir"
949 # Configure environment if we are doing a cross compile.
950 if [ $__CrossBuild == 1 ]; then
951 export CROSSCOMPILE=1
952 if ! [[ -n "$ROOTFS_DIR" ]]; then
953 export ROOTFS_DIR="$__ProjectRoot/cross/rootfs/$__BuildArch"
957 # init the target distro name
960 # Make the directories necessary for build if they don't exist
966 # Restore the package containing profile counts for profile-guided optimizations
969 # Generate event logging infrastructure sources
970 generate_event_logging_sources
972 # Build the coreclr (native) components.
973 __ExtraCmakeArgs="-DCLR_CMAKE_TARGET_OS=$__BuildOS -DCLR_CMAKE_PACKAGES_DIR=$__PackagesDir -DCLR_CMAKE_PGO_INSTRUMENT=$__PgoInstrument -DCLR_CMAKE_OPTDATA_VERSION=$__PgoOptDataVersion -DCLR_CMAKE_PGO_OPTIMIZE=$__PgoOptimize"
974 build_native $__SkipCoreCLR "$__BuildArch" "$__IntermediatesDir" "$__ExtraCmakeArgs" "CoreCLR component"
976 # Build cross-architecture components
977 if [[ $__CrossBuild == 1 && $__DoCrossArchBuild == 1 ]]; then
978 build_cross_arch_component
981 # Build System.Private.CoreLib.
985 # Generate nuget packages
986 if [ $__SkipNuget != 1 ]; then
987 generate_NugetPackages
993 echo "Repo successfully built."
994 echo "Product binaries are available at $__BinDir"